package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 数据集版本操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "数据集版本管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/datasetVersion")
public class DatasetVersionController {

    @Autowired
    private DatasetVersionService datasetVersionService;

    /**
     * 新增数据集版本数据。
     *
     * @param datasetVersionDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"datasetVersionDto.versionId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        datasetVersion = datasetVersionService.saveNew(datasetVersion);
        return ResponseResult.success(datasetVersion.getVersionId());
    }

    /**
     * 更新数据集版本数据。
     *
     * @param datasetVersionDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody DatasetVersionDto datasetVersionDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(datasetVersionDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        DatasetVersion datasetVersion = MyModelUtil.copyTo(datasetVersionDto, DatasetVersion.class);
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(datasetVersion.getVersionId());
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.update(datasetVersion, originalDatasetVersion)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除数据集版本数据。
     *
     * @param versionId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long versionId) {
        if (MyCommonUtil.existBlankArgument(versionId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(versionId);
    }

    /**
     * 列出符合过滤条件的数据集版本列表。
     *
     * @param datasetVersionDtoFilter 过滤对象。
     * @param datasetDetailDtoFilter 一对一从表过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<DatasetVersionVo>> list(
            @MyRequestBody DatasetVersionDto datasetVersionDtoFilter,
            @MyRequestBody DatasetDetailDto datasetDetailDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        DatasetVersion datasetVersionFilter = MyModelUtil.copyTo(datasetVersionDtoFilter, DatasetVersion.class);
        DatasetDetail datasetDetailFilter = MyModelUtil.copyTo(datasetDetailDtoFilter, DatasetDetail.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, DatasetVersion.class);
        List<DatasetVersion> datasetVersionList =
                datasetVersionService.getDatasetVersionListWithRelation(datasetVersionFilter, datasetDetailFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(datasetVersionList, DatasetVersion.INSTANCE));
    }

    /**
     * 查看指定数据集版本对象详情。
     *
     * @param versionId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<DatasetVersionVo> view(@RequestParam Long versionId) {
        DatasetVersion datasetVersion = datasetVersionService.getByIdWithRelation(versionId, MyRelationParam.full());
        if (datasetVersion == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        DatasetVersionVo datasetVersionVo = DatasetVersion.INSTANCE.fromModel(datasetVersion);
        return ResponseResult.success(datasetVersionVo);
    }

    private ResponseResult<Void> doDelete(Long versionId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        DatasetVersion originalDatasetVersion = datasetVersionService.getById(versionId);
        if (originalDatasetVersion == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!datasetVersionService.remove(versionId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
